class Raetsel {
	// Folgende Hilfsmethoden ersparen "new" in der Formel:
	static Aussage links_frei() {
		return new LinksFrei();
	}

	static Aussage rechts_frei() {
		return new RechtsFrei();
	}

	static Aussage nicht(Aussage a) {
		return new Nicht(a);
	}

	static Aussage links_tod() {
		return nicht(links_frei());
	}

	static Aussage rechts_tod() {
		return nicht(rechts_frei());
	}

	static Aussage und(Aussage a, Aussage b) {
		return new Und(a, b);
	}

	static Aussage oder(Aussage a, Aussage b) {
		return new Oder(a, b);
	}

	static Aussage entweder_oder(Aussage a, Aussage b) {
		return new EntwederOder(a, b);
	}

	public static void main(String[] args) {

		// Inschriften der Schilder an den Tueren:
		Aussage linkes_schild =
			und(links_frei(), rechts_tod());
		Aussage rechtes_schild =
			entweder_oder(links_frei(),
					rechts_frei());

		// Ein Hinweis ist richtig, der andere falsch:
		Aussage gesamt = entweder_oder(linkes_schild,
					rechtes_schild);

		// Nun die vier Belegungen testen:
		System.out.print("Links Frei,  Rechts Frei:  ");
		System.out.println(gesamt.wahr(true,true));

		System.out.print("Links Frei,  Rechts Tiger: ");
		System.out.println(gesamt.wahr(true,false));

		System.out.print("Links Tiger, Rechts Frei:  ");
		System.out.println(gesamt.wahr(false,true));

		System.out.print("Links Tiger, Rechts Tiger: ");
		System.out.println(gesamt.wahr(false,false));
	}
}
